mostly profanity and fixes
[distro-setup] / switch-mail-host
index 180b963c6b2f1da82955406864d74f217ebf9292..3a362c3b5ace6bc2409d8226c75e684b459c5a1c 100644 (file)
@@ -26,7 +26,7 @@ on the internet. Email can wait.
 
 Note: Uses GNU getopt options parsing style
 EOF
-  exit $1
+  exit 0
 }
 
 script_name="${BASH_SOURCE[0]}"
@@ -37,18 +37,19 @@ restore_old_btrbk=false
 err-cleanup() {
   if $restore_new_btrbk; then
     e WARNING: due to failure, btrbk.timer may need manual restoration:
-    e $new_shell systemctl start btrbk.timer btrbk-spread.timer  || (( $? == 5 ))
+    e $new_shell systemctl start btrbk.timer
   fi
   if $restore_old_btrbk; then
     e WARNING: due to failure, btrbk.timer may need manual restoration:
-    e $old_shell systemctl start btrbk.timer btrbk-spread.timer  || (( $? == 5 ))
+    e $old_shell systemctl start btrbk.timer
   fi
 }
 
-pre="${SSH_CLIENT:+$HOSTNAME} $script_name:"
+pre="$script_name:"
 m() { printf "$pre %s\n"  "$*"; "$@"; }
 e() { printf "$pre %s\n"  "$*"; }
 err() { echo "$pre ERROR: $*" >&2; }
+die() { printf "%s\n" "$*" >&2; echo "exiting with status 1" >&2; exit 1; }
 
 if [[ $EUID != 0 ]]; then
   err "requires running as root"
@@ -61,14 +62,28 @@ fi
 mail_only=false
 host2_only=false
 force=false
-mp_args="-m /o,/a,/ar,/q,/qr"
-temp=$(getopt -l force,help aioh "$@") || usage 1
+force_arg=
+pull_reexec=false
+mp_args="-m /o,/a,/ar,/q,/qd,/qr"
+check_installed=false
+orig_args=("$@")
+if ! temp=$(getopt -l check-installed,force,pull-reexec,help afioh "$@"); then
+  err "args invalid. args=$*"
+fi
 eval set -- "$temp"
 while true; do
   case $1 in
     -a) snapshot_arg=resume ;;
-    --force) force=true ;;
+    --force|-f)
+      force=true
+      force_arg=-f
+      ;;
+    --check-installed)
+      check_installed=true
+      ;;
     -i) incremental_arg="-i" ;;
+    # internal option for rerunning under newer old_host when doing pull
+    --pull-reexec) pull_reexec=true;;
     -o)
       mail_only=true ;;
     -h|--help) usage ;;
@@ -79,17 +94,47 @@ while true; do
 done
 
 
-(( $# == 2 )) || usage 1
+if (( $# != 2 )) && ! $check_installed; then
+  err expected 2 args, got $#
+fi
 
 if [[ ! $HOSTNAME ]]; then
   err "\$HOSTNAME is unset"
   exit 1
 fi
 
+uninstalled-file-die() {
+  die "on host=$HOSTNAME, uninstalled file $1. run install-my-scripts or rerun with -f"
+}
+
+
 source /a/bin/bash_unpublished/source-state
 
 direction=$1
 host=$2
+
+
+if ! $force && { $check_installed || [[ $direction == push ]]; } ; then
+  install_bin_files=(
+    mount-latest-subvol
+    check-subvol-stale
+    btrbk-run
+    switch-mail-host
+  )
+  for f in ${install_bin_files[@]}; do
+    if ! diff -q /a/bin/ds/$f /usr/local/bin/$f; then
+      uninstalled-file-die $f
+    fi
+  done
+  if ! diff -q /a/bin/errhandle/err /usr/local/lib/err; then
+    uninstalled-file-die err
+  fi
+  if $check_installed; then
+    exit 0
+  fi
+fi
+
+
 case $direction in
   push)
     old_host=$HOSTNAME
@@ -108,17 +153,32 @@ case $direction in
     new_hostname=$HOSTNAME
     bbk_args="-s $old_host"
     old_shell="ssh -F $HOME/.ssh/confighome root@$old_host"
-    old_shelliank="ssh -F $HOME/.ssh/confighome iank@$old_host"
     # tests ssh connection. crafted this to not need to do escape chars
+
+    if ! $mail_only && ! $pull_reexec ; then
+      if ! $force; then
+        if ! $old_shell switch-mail-host --check-installed; then
+          die "failed: $old_shell switch-mail-host --check-installed"
+        fi
+      fi
+      tmpf=$(mktemp)
+      m scp -F $HOME/.ssh/confighome root@$old_host:/usr/local/bin/switch-mail-host $tmpf
+      if ! diff -q $tmpf ${BASH_SOURCE[0]}; then
+        e "found different version on old_host=$old_hostname, reexecing"
+        m install -T $tmpf /usr/local/bin/switch-mail-host
+        m /usr/local/bin/switch-mail-host --pull-reexec "${orig_args[@]}"
+        mexit 0
+      fi
+    fi
+
     f=/a/bin/bash_unpublished/source-state
-    if ! old_info=($($old_shell "hostname; sed -n s,.*MAIL_HOST=,,p $f; sed -n s,.*HOST2=,,p $f")); then
+    if ! old_info=$($old_shell "hostname; sed -n s,.*MAIL_HOST=,,p $f; sed -n s,.*HOST2=,,p $f"); then
       echo "$pre: error: failed ssh. retrying failed $old_shell with -v for more info:"
       $old_shell -v hostname
       exit 1
     fi
-    old_hostname=${old_info[0]}
-    MAIL_HOST=${old_info[1]}
-    HOST2=${old_info[2]}
+    read -d '' -r old_hostname MAIL_HOST HOST2 <<<"$old_info" || (( $? == 1 ))
+
     ;;
   *)
     err invalid first argument
@@ -143,7 +203,7 @@ esac
 if $mail_only; then
   mp_args="-m /o"
 elif $host2_only; then
-  mp_args="-m /a,/ar,/q,/qr"
+  mp_args="-m /a,/ar,/q,/qd,/qr"
 fi
 
 if ! $force; then
@@ -167,11 +227,11 @@ fi
 ########### end initial processing, begin actually modifying things ##########
 
 if $new_shell systemctl is-active btrbk.timer; then
-  m $new_shell systemctl stop btrbk.timer btrbk-spread.timer || (( $? == 5 ))
+  m $new_shell systemctl stop btrbk.timer
   restore_new_btrbk=true
 fi
 if $old_shell systemctl is-active btrbk.timer; then
-  m $old_shell systemctl stop btrbk.timer btrbk-spread.timer || (( $? == 5 ))
+  m $old_shell systemctl stop btrbk.timer
   restore_old_btrbk=true
 fi
 
@@ -221,7 +281,9 @@ EOF
   fi
 } | $new_shell bash -s
 
-$old_shell bash -s <<'EOF'
+if ! $mail_only; then
+  $old_shell bash -s <<'EOF'
+set -e
 if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
   bufs="$(sudo -u iank env XDG_RUNTIME_DIR=/run/user/1000 emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
   if [[ $bufs ]]; then
@@ -229,7 +291,16 @@ if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
     exit 1
   fi
 fi
+
+# Try to prevent emacs from saving stale data it has in memory to disk. eg: files, recentf list, etc.
+# But if emacs ignores the signal, let it live.
+killall -q emacs ||:
+
+if [[ -e /p/profanity-here ]]; then
+  systemctl disable --now profanity
+fi
 EOF
+fi
 
 # previously, I was checking to see if the new mail host
 # is on my home network, then changing my home dns
@@ -247,7 +318,7 @@ EOF
 
 
 e Running initial btrbk
-m btrbk-run -v $bbk_args $incremental_arg $mp_args $snapshot_arg || ret=$?
+m btrbk-run -v $bbk_args $force_arg $incremental_arg $mp_args $snapshot_arg || ret=$?
 if (( ret )); then
   err "failed initial btrbk"
   exit $ret
@@ -260,10 +331,12 @@ fi
 
 if $host2_only; then
   if [[ $old_hostname != "$MAIL_HOST" && $old_hostname != kd ]]; then
-    # most systems dont have btrbk-spread, systemctl exits 5 on unknown unit
-    m $old_shell systemctl --now disable btrbk.timer btrbk-spread.timer || (( $? == 5 ))
+    m $old_shell systemctl --now disable btrbk.timer
+  fi
+  m $new_shell systemctl --now enable btrbk.timer
+  if [[ -e /p/profanity-here ]]; then
+    m $new_shell systemctl --now enable profanity
   fi
-  m $new_shell systemctl --now enable btrbk.timer btrbk-spread.timer  || (( $? == 5 ))
   exit 0
 fi
 
@@ -273,12 +346,9 @@ if (( ret )); then
   exit $ret
 fi
 
-# Try to prevent emacs from saving stale data it has in memory to disk. eg: files, recentf list, etc.
-# But if emacs ignores the signal, let it live.
-m $new_shell killall -q emacs ||:
 
 e Running main btrbk
-m btrbk-run -v --fast $bbk_args $incremental_arg -m /o || ret=$?
+m btrbk-run -v --fast $bbk_args $force_arg $incremental_arg -m /o || ret=$?
 if (( ret )); then
   bang="$(printf "$(tput setaf 5)█$(tput sgr0)%.0s" 1 2 3 4 5 6 7)"
   e $bang failed btrbk of /o. restoring old host as primary
@@ -287,8 +357,8 @@ if (( ret )); then
 fi
 
 # new system is usable at this point
-printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
-echo
+blocks=██████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
+printf "%s\n" "$(tput setaf 5 2>/dev/null ||:)${blocks:0:${COLUMNS:-180}}$(tput sgr0 2>/dev/null||:)"
 
 # once I accidentally accepted incoming mail on old host. I used this script to copy over that mail:
 #
@@ -304,4 +374,12 @@ if (( ret )); then
   exit $ret
 fi
 
+if ! $mail_only && [[ -e /p/profanity-here ]]; then
+  m $new_shell systemctl --now enable profanity || ret=$?
+  if (( ret )); then
+    err "failed final systemctl --now enable profanity, just fix and rerun"
+    exit $ret
+  fi
+fi
+
 m exit 0